<script setup>
////////////////////////////////
// IMPORT
////////////////////////////////

import { useNodeStore } from "@/stores/useNodeStore";
import { useNotificationStore } from "@/stores/useNotificationStore";
import { useWebsocketStore } from "@/stores/useWebsocketStore";
import { useWorkspaceStore } from "@/stores/useWorkspaceStore";
import { computed, ref, watch } from "vue";

////////////////////////////////
// STORE
////////////////////////////////

const workspaceStore = useWorkspaceStore();
const notificationStore = useNotificationStore();
const websocketStore = useWebsocketStore();
const nodeStore = useNodeStore();

////////////////////////////////
// VARIABLES
////////////////////////////////

const workspaces = ref(workspaceStore.workspaceMap);
const menu = ref(false);
const newWorkspaceDialog = ref(false);

////////////////////////////////
// FUNCTIONS
////////////////////////////////

const isWebSocketWorkspace = computed(() => {
  const currentWorkspaceId = workspaceStore.currentWid;
  return websocketStore.message?.description === currentWorkspaceId;
});

const showRedDot = computed(() => {
  const currentWorkspaceId = workspaceStore.currentWid;
  const otherWorkspacesWithNotifications = Array.from(notificationStore.notifications.values())
    .filter(notification => notification.description !== currentWorkspaceId)
    .map(notification => notification.description);

  // Check if the menu is expanded
  if (menu.value) {
    // Show red dot only on the workspace item corresponding to the WebSocket workspace ID
    return (
      isWebSocketWorkspace.value
      && otherWorkspacesWithNotifications.includes(websocketStore.message?.description)
    );
  } else {
    // Show red dot on the current workspace item
    return notificationStore.countUnreadMessage !== 0;
  }
});

const allDescriptions = new Set();
const otherWorkspacesWithNotifications = computed(() => {
  const description = websocketStore.message?.data.description;
  if (description) {
    allDescriptions.add(description);
    return Array.from(allDescriptions);
  } else {
    return [];
  }
});

async function setCurrentWorkspace(workspace) {
  workspaceStore.currentWSlug = workspace.slug;
  nodeStore.currentNid = null;
  await navigateTo(`/${workspace.slug}`);
}

////////////////////////////////
// WATCH
////////////////////////////////

watch(
  () => notificationStore.notifications,
  () => {
    workspaces.value = workspaceStore.workspaceMap;
  },
);

watch(
  () => workspaceStore.currentWid,
  async (newWorkspaceId, oldWorkspaceId) => {
    if (newWorkspaceId !== oldWorkspaceId) {
      await nodeStore.fetchNodes();
    }
  },
);
</script>

<template>
  <div class="mb-3">
    <v-menu
      v-model="menu"
      location="bottom"
      style="max-width: 300px"
    >
      <template v-slot:activator="{ props }">
        <v-btn
          variant="outlined"
          block
          class="d-flex justify-space-between"
          :append-icon="menu ? 'mdi-chevron-up' : 'mdi-chevron-down'"
          v-bind="props"
        >
          <span class="text-truncate" style="max-width: 250px">
            {{ workspaceStore.currentWorkspace.name }}
          </span>
          <v-badge
            v-if="showRedDot"
            dot
            color="error"
            style="position: absolute; top: 14px; right: 29px"
          />
        </v-btn>
      </template>

      <v-list density="comfortable">
        <v-list-item
          v-for="(item, index) in Object.values(Object.fromEntries(workspaces))"
          :key="index"
          @click="setCurrentWorkspace(item)"
        >
          <v-list-item-title
            class="text-truncate"
            style="flex: 1; display: flex; justify-content: space-between; align-items: center"
          >
            <span>{{ truncateTitle(item.name) }}</span>
            <div style="display: flex; margin-left: 60%">
              <v-badge
                v-if="otherWorkspacesWithNotifications.includes(item.id)"
                inline
                dot
                color="error"
              />
            </div>
            <div style="display: flex; align-items: center">
              <template v-if="item.slug === workspaceStore.currentWSlug">
                <v-icon icon="mdi-check" style="margin-left: 4px" />
              </template>
            </div>
          </v-list-item-title>
        </v-list-item>
        <v-divider
          thickness="1.5"
          class="my-2 mx-15"
          style="opacity: 100% !important"
        />
        <v-list-item @click="newWorkspaceDialog = true">
          <v-icon icon="mdi-plus-circle-outline" class="mr-2" /> New Workspace
        </v-list-item>
      </v-list>
    </v-menu>
  </div>

  <WorkspaceNew
    :newWorkspaceDialog="newWorkspaceDialog"
    @newWorkspaceDialog="newWorkspaceDialog = false"
  />
</template>
